Exemplo n.º 1
0
        /// <summary>
        /// Implement this method as an external command for Revit.
        /// </summary>
        /// <param name="commandData">An object that is passed to the external application
        /// which contains data related to the command,
        /// such as the application object and active view.</param>
        /// <param name="message">A message that can be set by the external application
        /// which will be displayed if a failure or cancellation is returned by
        /// the external command.</param>
        /// <param name="elements">A set of elements to which the external application
        /// can add elements that are to be highlighted in case of failure or cancellation.</param>
        /// <returns>Return the status of the external command.
        /// A result of Succeeded means that the API external method functioned as expected.
        /// Cancelled can be used to signify that the user cancelled the external operation
        /// at some point. Failure should be returned if the application is unable to proceed with
        /// the operation.</returns>
        public Autodesk.Revit.UI.Result Execute(Autodesk.Revit.UI.ExternalCommandData commandData,
                                                ref string message,
                                                ElementSet elements)
        {
            // Get the application of revit
            Autodesk.Revit.UI.UIApplication revit = commandData.Application;
            m_document = revit.ActiveUIDocument.Document;

            try
            {
                ElementSet elementSet = new ElementSet();
                foreach (ElementId elementId in revit.ActiveUIDocument.Selection.GetElementIds())
                {
                    elementSet.Insert(revit.ActiveUIDocument.Document.GetElement(elementId));
                }
                if (elementSet.IsEmpty)
                {
                    TaskDialog.Show("Select", "Please select one floor or slab at least.");
                    return(Autodesk.Revit.UI.Result.Cancelled);
                }
                using (m_displayForm = new DeckPropertyForm())
                {
                    List <Floor> floorList = new List <Floor>();
                    foreach (ElementId elementId in revit.ActiveUIDocument.Selection.GetElementIds())
                    {
                        Element element = revit.ActiveUIDocument.Document.GetElement(elementId);
                        Floor   floor   = element as Floor;
                        if (floor != null)
                        {
                            floorList.Add(floor);
                        }
                    }

                    if (floorList.Count <= 0)
                    {
                        TaskDialog.Show("Select", "Please select one floor or slab at least.");
                        return(Autodesk.Revit.UI.Result.Cancelled);
                    }

                    foreach (Floor floor in floorList)
                    {
                        DumpSlab(floor);
                    }
                    m_displayForm.ShowDialog();
                }
            }
            catch (Exception ex)
            {
                // If any error, store error information in message and return failed
                message = ex.Message;
                return(Autodesk.Revit.UI.Result.Failed);
            }
            // If everything goes well, return succeeded.
            return(Autodesk.Revit.UI.Result.Succeeded);
        }
Exemplo n.º 2
0
        /// <summary>
        /// Implement this method as an external command for Revit.
        /// </summary>
        /// <param name="commandData">An object that is passed to the external application 
        /// which contains data related to the command, 
        /// such as the application object and active view.</param>
        /// <param name="message">A message that can be set by the external application 
        /// which will be displayed if a failure or cancellation is returned by 
        /// the external command.</param>
        /// <param name="elements">A set of elements to which the external application 
        /// can add elements that are to be highlighted in case of failure or cancellation.</param>
        /// <returns>Return the status of the external command. 
        /// A result of Succeeded means that the API external method functioned as expected. 
        /// Cancelled can be used to signify that the user cancelled the external operation 
        /// at some point. Failure should be returned if the application is unable to proceed with 
        /// the operation.</returns>
        public Autodesk.Revit.UI.Result Execute(Autodesk.Revit.UI.ExternalCommandData commandData,
                                               ref string message,
                                               ElementSet elements)
        {
            // Get the application of revit
            Autodesk.Revit.UI.UIApplication revit = commandData.Application;
            m_document = revit.ActiveUIDocument.Document;

            try
            {
                if (revit.ActiveUIDocument.Selection.Elements.IsEmpty)
                {
                    System.Windows.Forms.MessageBox.Show("Please select one floor or slab at least.");
                    return Autodesk.Revit.UI.Result.Cancelled;
                }
                using (m_displayForm = new DeckPropertyForm())
                {
                    List<Floor> floorList = new List<Floor>();
                    foreach (Element element in revit.ActiveUIDocument.Selection.Elements)
                    {
                        Floor floor = element as Floor;
                        if (floor != null)
                        {
                            floorList.Add(floor);
                        }
                    }

                    if (floorList.Count <= 0)
                    {
                        System.Windows.Forms.MessageBox.Show("Please select one floor or slab at least.");
                        return Autodesk.Revit.UI.Result.Cancelled;
                    }

                    foreach (Floor floor in floorList)
                    {
                        DumpSlab(floor);
                    }
                    m_displayForm.ShowDialog();
                }
            }
            catch (Exception ex)
            {
                // If any error, store error information in message and return failed
                message = ex.Message;
                return Autodesk.Revit.UI.Result.Failed;
            }
            // If everything goes well, return succeeded.
            return Autodesk.Revit.UI.Result.Succeeded;
        }